/********************************** (C) COPYRIGHT *******************************
 * File Name          : Main.c
 * Author             : WCH
 * Version            : V1.1
 * Date               : 2022/01/25
 * Description        : ģHID豸
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for 
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/

#include "CH59x_common.h"

#define DevEP0SIZE    0x40
// 豸
const uint8_t MyDevDescr[] = {0x12,0x01,0x10,0x01,0x00,0x00,0x00,DevEP0SIZE,0x3d,0x41,0x07,0x21,0x00,0x00,0x00,0x00,0x00,0x01};
// 
const uint8_t MyCfgDescr[] = {
    0x09,0x02,0x29,0x00,0x01,0x01,0x04,0xA0,0x23,               //
    0x09,0x04,0x00,0x00,0x02,0x03,0x00,0x00,0x05,               //ӿ
    0x09,0x21,0x00,0x01,0x00,0x01,0x22,0x22,0x00,               //HID
    0x07,0x05,0x81,0x03,0x40,0x00,0x01,              //˵
    0x07,0x05,0x01,0x03,0x40,0x00,0x01               //˵
};
/*ַ*/
/*HID౨*/
const uint8_t HIDDescr[] = {  0x06, 0x00,0xff,
                              0x09, 0x01,
                              0xa1, 0x01,                                                   //Ͽʼ
                              0x09, 0x02,                                                   //Usage Page  ÷
                              0x15, 0x00,                                                   //Logical  Minimun
                              0x26, 0x00,0xff,                                              //Logical  Maximun
                              0x75, 0x08,                                                   //Report Size
                              0x95, 0x40,                                                   //Report Counet
                              0x81, 0x06,                                                   //Input
                              0x09, 0x02,                                                   //Usage Page  ÷
                              0x15, 0x00,                                                   //Logical  Minimun
                              0x26, 0x00,0xff,                                              //Logical  Maximun
                              0x75, 0x08,                                                   //Report Size
                              0x95, 0x40,                                                   //Report Counet
                              0x91, 0x06,                                                   //Output
                              0xC0};

/**********************************************************/
uint8_t        DevConfig, Ready = 0;
uint8_t        SetupReqCode;
uint16_t       SetupReqLen;
const uint8_t *pDescr;
uint8_t        Report_Value = 0x00;
uint8_t        Idle_Value = 0x00;
uint8_t        USB_SleepStatus = 0x00; /* USB˯״̬ */

//HID豸жϴϴ4ֽڵ
uint8_t HID_Buf[] = {0,0,0,0};

/******** ûԶ˵RAM ****************************************/
__attribute__((aligned(4))) uint8_t EP0_Databuf[64 + 64 + 64]; //ep0(64)+ep4_out(64)+ep4_in(64)
__attribute__((aligned(4))) uint8_t EP1_Databuf[64 + 64];      //ep1_out(64)+ep1_in(64)
__attribute__((aligned(4))) uint8_t EP2_Databuf[64 + 64];      //ep2_out(64)+ep2_in(64)
__attribute__((aligned(4))) uint8_t EP3_Databuf[64 + 64];      //ep3_out(64)+ep3_in(64)

/*********************************************************************
 * @fn      USB_DevTransProcess
 *
 * @brief   USB 䴦
 *
 * @return  none
 */
void USB_DevTransProcess(void)  //USB豸жϴ
{
    uint8_t len, chtype;        //lenڿchtypeڴݴ䷽͡յĶϢ
    uint8_t intflag, errflag = 0;   //intflagڴű־ĴֵerrflagڱǷָ֧

    intflag = R8_USB_INT_FG;        //ȡжϱʶĴֵ

    if(intflag & RB_UIF_TRANSFER)   //ж_INT_FGеUSBжϱ־λджˣif
    {
        if((R8_USB_INT_ST & MASK_UIS_TOKEN) != MASK_UIS_TOKEN) // ǿ   //жж״̬Ĵе5:4λ鿴ƵPIDʶλ11ʾУif
        {
            switch(R8_USB_INT_ST & (MASK_UIS_TOKEN | MASK_UIS_ENDP))    //ȡƵPIDʶ豸ģʽµ3:0λĶ˵šģʽ3:0λӦPIDʶλ
            // ƺͶ˵
            {                           //˵0ڿƴ䡣µĶ˵0INOUTӦ򣬶Ӧƴݽ׶κ״̬׶Ρ
                case UIS_TOKEN_IN:      //ưPIDΪIN5:4λΪ103:0λĶ˵Ϊ0INƣ豸ݡ_UIS_USBж״̬
                {                       //˵0Ϊ˫˵㣬ƴ䡣 |0ʡ
                    switch(SetupReqCode)//ֵյSETUPʱֵںSETUP򣬶Ӧƴý׶Ρ
                    {
                        case USB_GET_DESCRIPTOR:    //USB׼USB豸ȡ
                            len = SetupReqLen >= DevEP0SIZE ? DevEP0SIZE : SetupReqLen; // ΰ䳤ȡΪ64ֽڣ64ֽڵķֶδǰҪ
                            memcpy(pEP0_DataBuf, pDescr, len);//memcpy:ڴ濽(λ)ַ(λ)ַȵ(һλ)ַ
                            //DMAֱڴ⵽ڴĸдõƬƾͿԽڴеݷͳȥֻ黥ำֵ漰DMAƥڴ棬޷DMA
                            SetupReqLen -= len;     //¼ʣµҪ͵ݳ
                            pDescr += len;          //½Ҫ͵ݵʼַ,
                            R8_UEP0_T_LEN = len;    //˵0ͳȼĴд뱾ΰ䳤
                            R8_UEP0_CTRL ^= RB_UEP_T_TOG;   // ͬлIN򣨶ڵƬT򣩵PIDеDATA0DATA1л
                            break;                  //ֵ˵ƼĴְӦACKNAKSTALLӲɷϹ淶İDMAԶ
                        case USB_SET_ADDRESS:       //USB׼Ϊ豸һΨһַΧ01270ΪĬϵַ
                            R8_USB_DEV_AD = (R8_USB_DEV_AD & RB_UDA_GP_BIT) | SetupReqLen;
                                    //7λַ+λûԶַĬΪ1ϡ䳤ȡġ䳤ȡں渳ֵ˵ַλ
                            R8_UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                                    //RӦOUTACKTӦINNAKCASE֧IN򣬵DMAӦڴУƬûݸʱNAKְ
                            break;                                                  //һOUT豸ذӦNAK

                        case USB_SET_FEATURE:       //USB׼Ҫһ豸ӿڻ˵ϵ
                            break;

                        default:
                            R8_UEP0_T_LEN = 0;      //״̬׶жϻǿϴ0ݰƴ䣨ֶγΪ0ݰSYNCPIDEOPֶζУ
                            R8_UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                                    //RӦOUTACKTӦINNAKCASE֧OUT򣬵DMAӦڴиҵƬʱACKְ
                            Ready = 1;
                            PRINT("Ready_STATUS = %d\n",Ready);
                            break;
                    }
                }
                break;

                case UIS_TOKEN_OUT:     //ưPIDΪOUT5:4λΪ003:0λĶ˵Ϊ0OUTƣ豸ݡ
                {                       //˵0Ϊ˫˵㣬ƴ䡣 |0ʡ
                    len = R8_USB_RX_LEN;    //ȡǰUSBճȼĴд洢Ľյֽ //ճȼĴΪ˵㹲ãͳȼĴи
                }
                break;

                case UIS_TOKEN_OUT | 1: //ưPIDΪOUT˵Ϊ1
                {
                    if(R8_USB_INT_ST & RB_UIS_TOG_OK)   //ӲжǷȷͬлݰͬлȷһλԶλ
                    { // ͬݰ
                        R8_UEP1_CTRL ^= RB_UEP_R_TOG;   //OUTDATAͬл趨һֵ
                        len = R8_USB_RX_LEN;        //ȡݵֽ
                        DevEP1_OUT_Deal(len);       //ͳΪlenֽڣԶACKְԶĳ
                    }
                }
                break;

                case UIS_TOKEN_IN | 1: //ưPIDΪIN˵Ϊ1
                    R8_UEP1_CTRL ^= RB_UEP_T_TOG;       //INDATAлһ¡趨Ҫ͵İPID
                    R8_UEP1_CTRL = (R8_UEP1_CTRL & ~MASK_UEP_T_RES) | UEP_T_RES_NAK;    //DMAûɵƬʱTӦINΪNAK˾ͷݡ
                    Ready = 1;
                    PRINT("Ready_IN_EP1 = %d\n",Ready);
                    break;
            }
            R8_USB_INT_FG = RB_UIF_TRANSFER;    //д1жϱ־
        }

        if(R8_USB_INT_ST & RB_UIS_SETUP_ACT) // Setup
        {
            R8_UEP0_CTRL = RB_UEP_R_TOG | RB_UEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
                        //RӦOUTڴΪDATA1DMAյݰPIDҪΪDATA1ݴҪشACKDMAӦڴյݣƬ
                        //TӦIN趨ΪDATA1ƬDMAӦڴ棬DATA1ͳȥNAKƬû׼ݣ
            SetupReqLen = pSetupReqPak->wLength;    //ݽ׶εֽ      //pSetupReqPak˵0RAMַǿתһŽṹĵַṹԱν
            SetupReqCode = pSetupReqPak->bRequest;  //
            chtype = pSetupReqPak->bRequestType;    //ݴ䷽͡յĶϢ

            len = 0;
            errflag = 0;
            if((pSetupReqPak->bRequestType & USB_REQ_TYP_MASK) != USB_REQ_TYP_STANDARD) //жͣǱ׼󣬽if
            {
                /* Ǳ׼ */
                /* ,󣬲 */
                if(pSetupReqPak->bRequestType & 0x40)   //ȡеĳһλжǷΪ0Ϊif
                {
                    /*  */
                }
                else if(pSetupReqPak->bRequestType & 0x20)  //ȡеĳһλжǷΪ0Ϊif
                {   //жΪHID
                    switch(SetupReqCode)    //ж
                    {
                        case DEF_USB_SET_IDLE: /* 0x0A: SET_IDLE */         //HID豸ض뱨Ŀʱ
                            Idle_Value = EP0_Databuf[3];
                            break; //һҪ

                        case DEF_USB_SET_REPORT: /* 0x09: SET_REPORT */     //HID豸ı
                            break;

                        case DEF_USB_SET_PROTOCOL: /* 0x0B: SET_PROTOCOL */ //HID豸ǰʹõЭ
                            Report_Value = EP0_Databuf[2];
                            break;

                        case DEF_USB_GET_IDLE: /* 0x02: GET_IDLE */         //ȡHID豸ض뱨ĵǰĿб
                            EP0_Databuf[0] = Idle_Value;
                            len = 1;
                            break;

                        case DEF_USB_GET_PROTOCOL: /* 0x03: GET_PROTOCOL */     //HID豸ǰʹõЭ
                            EP0_Databuf[0] = Report_Value;
                            len = 1;
                            break;

                        default:
                            errflag = 0xFF;
                    }
                }
            }
            else    //жΪ׼
            {
                switch(SetupReqCode)    //ж
                {
                    case USB_GET_DESCRIPTOR:    //ñ׼
                    {
                        switch(((pSetupReqPak->wValue) >> 8))   //8λԭĸ8λǷΪ0Ϊ1ʾΪINs-case
                        {
                            case USB_DESCR_TYP_DEVICE:  //ֵͬͬ豸
                            {
                                pDescr = MyDevDescr;    //豸ַpDescrַУñ׼caseĩβÿ
                                len = MyDevDescr[0];    //Э涨豸ֽڴֽȡõlen
                            }
                            break;

                            case USB_DESCR_TYP_CONFIG:  //
                            {
                                pDescr = MyCfgDescr;    //ַpDescrַУ֮ᷢ
                                len = MyCfgDescr[2];    //Э涨ĵֽڴϢܳ
                            }
                            break;

                            case USB_DESCR_TYP_HID:     //˻ӿ˴ṹеwIndexͬΪӿںš
                                switch((pSetupReqPak->wIndex) & 0xff)       //ȡͰλ߰λĨȥ
                                {
                                    /* ѡӿ */
                                    case 0:
                                        pDescr = (uint8_t *)(&MyCfgDescr[18]);  //ӿ1λã
                                        len = 9;
                                        break;

                                    default:
                                        /* ֵַ֧ */
                                        errflag = 0xff;
                                        break;
                                }
                                break;

                            case USB_DESCR_TYP_REPORT:  //豸
                            {
                                if(((pSetupReqPak->wIndex) & 0xff) == 0) //ӿ0
                                {
                                    pDescr = HIDDescr; //׼ϴ
                                    len = sizeof(HIDDescr);
                                }
                                else
                                    len = 0xff; //ֻ2ӿڣ仰ִ
                            }
                            break;

                            case USB_DESCR_TYP_STRING:  //豸ַ
                            {
                                switch((pSetupReqPak->wValue) & 0xff)   //wValueֵַϢ
                                {
                                    default:
                                        errflag = 0xFF; // ֵַ֧
                                        break;
                                }
                            }
                            break;

                            default:
                                errflag = 0xff;
                                break;
                        }
                        if(SetupReqLen > len)
                            SetupReqLen = len;      //ʵϴܳ
                        len = (SetupReqLen >= DevEP0SIZE) ? DevEP0SIZE : SetupReqLen;   //󳤶Ϊ64ֽ
                        memcpy(pEP0_DataBuf, pDescr, len);  //
                        pDescr += len;
                    }
                    break;

                    case USB_SET_ADDRESS:       //豸ַ
                        SetupReqLen = (pSetupReqPak->wValue) & 0xff;    //ַλ豸ַݴSetupReqLen
                        break;                                          //ƽ׶λḳֵ豸ַ

                    case USB_GET_CONFIGURATION: //豸ǰ
                        pEP0_DataBuf[0] = DevConfig;    //豸÷ŽRAM
                        if(SetupReqLen > 1)
                            SetupReqLen = 1;    //ݽ׶εֽ1ΪDevConfigֻһֽ
                        break;

                    case USB_SET_CONFIGURATION: //豸ǰ
                        DevConfig = (pSetupReqPak->wValue) & 0xff;  //ȡͰλ߰λĨȥ
                        break;

                    case USB_CLEAR_FEATURE:     //رUSB豸/ܡ豸Ƕ˵ϵġ
                    {
                        if((pSetupReqPak->bRequestType & USB_REQ_RECIP_MASK) == USB_REQ_RECIP_ENDP) //жǲǶ˵˵ֹͣ״̬
                        {
                            switch((pSetupReqPak->wIndex) & 0xff)   //ȡͰλ߰λĨȥж
                            {       //16λλжݴ䷽0ΪOUT1ΪINλΪ˵š
                                case 0x81:      //_TOG_T_RESλд_NAKӦINNAKʾݷ
                                    R8_UEP1_CTRL = (R8_UEP1_CTRL & ~(RB_UEP_T_TOG | MASK_UEP_T_RES)) | UEP_T_RES_NAK;
                                    break;
                                case 0x01:      //_TOG_R_RESλд_ACKӦOUTACKʾ
                                    R8_UEP1_CTRL = (R8_UEP1_CTRL & ~(RB_UEP_R_TOG | MASK_UEP_R_RES)) | UEP_R_RES_ACK;
                                    break;
                                default:
                                    errflag = 0xFF; // ֵ֧Ķ˵
                                    break;
                            }
                        }
                        else if((pSetupReqPak->bRequestType & USB_REQ_RECIP_MASK) == USB_REQ_RECIP_DEVICE)  //жǲ豸豸ѣ
                        {
                            if(pSetupReqPak->wValue == 1)   //ѱ־λΪ1
                            {
                                USB_SleepStatus &= ~0x01;   //λ
                            }
                        }
                        else
                        {
                            errflag = 0xFF;
                        }
                    }
                    break;

                    case USB_SET_FEATURE:       //USB豸/ܡ豸Ƕ˵ϵġ
                        if((pSetupReqPak->bRequestType & USB_REQ_RECIP_MASK) == USB_REQ_RECIP_ENDP) //жǲǶ˵ʹ˵ֹͣ
                        {
                            /* ˵ */
                            switch(pSetupReqPak->wIndex)    //ж
                            {       //16λλжݴ䷽0ΪOUT1ΪINλΪ˵š
                                case 0x81:      //_TOG_T_RESλд_STALLָֹͣ˵Ĺ
                                    R8_UEP1_CTRL = (R8_UEP1_CTRL & ~(RB_UEP_T_TOG | MASK_UEP_T_RES)) | UEP_T_RES_STALL;
                                    break;
                                case 0x01:      //_TOG_R_RESλд_STALLָֹͣ˵Ĺ
                                    R8_UEP1_CTRL = (R8_UEP1_CTRL & ~(RB_UEP_R_TOG | MASK_UEP_R_RES)) | UEP_R_RES_STALL;
                                    break;
                                default:
                                    /* ֵ֧Ķ˵ */
                                    errflag = 0xFF; // ֵ֧Ķ˵
                                    break;
                            }
                        }
                        else if((pSetupReqPak->bRequestType & USB_REQ_RECIP_MASK) == USB_REQ_RECIP_DEVICE)  //жǲ豸ʹ豸ߣ
                        {
                            if(pSetupReqPak->wValue == 1)
                            {
                                USB_SleepStatus |= 0x01;    //˯
                            }
                        }
                        else
                        {
                            errflag = 0xFF;
                        }
                        break;

                    case USB_GET_INTERFACE:     //ýӿڵǰѡֵ
                        pEP0_DataBuf[0] = 0x00;
                        if(SetupReqLen > 1)
                            SetupReqLen = 1;    //ݽ׶εֽ1Ϊֻһֽ
                        break;

                    case USB_SET_INTERFACE:     //뼤豸ĳӿ
                        break;

                    case USB_GET_STATUS:        //豸ӿڻǶ˵״̬
                        if((pSetupReqPak->bRequestType & USB_REQ_RECIP_MASK) == USB_REQ_RECIP_ENDP) //жǷΪ˵״̬
                        {
                            /* ˵ */
                            pEP0_DataBuf[0] = 0x00;
                            switch(pSetupReqPak->wIndex)
                            {       //16λλжݴ䷽0ΪOUT1ΪINλΪ˵š
                                case 0x81:      //ж_TOG_T_RESλSTALL״̬if
                                    if((R8_UEP1_CTRL & (RB_UEP_T_TOG | MASK_UEP_T_RES)) == UEP_T_RES_STALL)
                                    {
                                        pEP0_DataBuf[0] = 0x01; //D0Ϊ1ʾ˵㱻ֹͣˡλSET_FEATURECLEAR_FEATUREá
                                    }
                                    break;

                                case 0x01:      //ж_TOG_R_RESλSTALL״̬if
                                    if((R8_UEP1_CTRL & (RB_UEP_R_TOG | MASK_UEP_R_RES)) == UEP_R_RES_STALL)
                                    {
                                        pEP0_DataBuf[0] = 0x01;
                                    }
                                    break;
                            }
                        }
                        else if((pSetupReqPak->bRequestType & USB_REQ_RECIP_MASK) == USB_REQ_RECIP_DEVICE)  //жǷΪ豸״̬
                        {
                            pEP0_DataBuf[0] = 0x00;
                            if(USB_SleepStatus)     //豸˯״̬
                            {
                                pEP0_DataBuf[0] = 0x02;     //λD0Ϊ0ʾ豸߹磬Ϊ1ʾ豸Թ硣 D1λΪ1ʾ֧Զ̻ѣΪ0ʾ֧֡
                            }
                            else
                            {
                                pEP0_DataBuf[0] = 0x00;
                            }
                        }
                        pEP0_DataBuf[1] = 0;    //״̬ϢĸʽΪ16λ߰λΪ0
                        if(SetupReqLen >= 2)
                        {
                            SetupReqLen = 2;    //ݽ׶εֽ2Ϊֻ2ֽ
                        }
                        break;

                    default:
                        errflag = 0xff;
                        break;
                }
            }
            if(errflag == 0xff) // ֧
            {
                //                  SetupReqCode = 0xFF;
                R8_UEP0_CTRL = RB_UEP_R_TOG | RB_UEP_T_TOG | UEP_R_RES_STALL | UEP_T_RES_STALL; // STALL
                Ready = 1;
                PRINT("Ready_Stall = %d\n",Ready);
            }
            else
            {
                if(chtype & 0x80)   // ϴλΪ1ݴ䷽Ϊ豸䡣
                {
                    len = (SetupReqLen > DevEP0SIZE) ? DevEP0SIZE : SetupReqLen;
                    SetupReqLen -= len;
                }
                else
                    len = 0;        // ´λΪ0ݴ䷽Ϊ豸䡣
                R8_UEP0_T_LEN = len;
                R8_UEP0_CTRL = RB_UEP_R_TOG | RB_UEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;     // ĬݰDATA1
            }

            R8_USB_INT_FG = RB_UIF_TRANSFER;    //д1жϱʶ
        }
    }


    else if(intflag & RB_UIF_BUS_RST)   //ж_INT_FGе߸λ־λΪ1
    {
        R8_USB_DEV_AD = 0;      //豸ַд0·豸һµַ
        R8_UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;   //Ѷ˵0ĿƼĴдɣӦӦACKʾյӦNAKʾûҪ
        R8_UEP1_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
        R8_UEP2_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
        R8_UEP3_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
        R8_USB_INT_FG = RB_UIF_BUS_RST; //д1жϱʶ
    }
    else if(intflag & RB_UIF_SUSPEND)   //ж_INT_FGе߹¼жϱ־λͻѶᴥж
    {
        if(R8_USB_MIS_ST & RB_UMS_SUSPEND)  //ȡ״̬ĴеĹ״̬λΪ1ʾUSBߴڹ̬Ϊ0ʾߴڷǹ̬
        {
            Ready = 0;
            PRINT("Ready_Sleep = %d\n",Ready);
        } //      //豸ڿ״̬3msҪ豸ڵߣ
        else    //жϱûбжΪ
        {
            Ready = 1;
            PRINT("Ready_WeakUp = %d\n",Ready);
        } // 
        R8_USB_INT_FG = RB_UIF_SUSPEND; //д1жϱ־
    }
    else
    {
        R8_USB_INT_FG = intflag;    //_INT_FGûжϱʶٰԭֵдԭļĴ
    }
}

/*********************************************************************
 * @fn      DevHIDReport
 *
 * @brief   ϱHID
 *
 * @return  0ɹ
 *          1
 */
void DevHIDReport(uint8_t data0,uint8_t data1,uint8_t data2,uint8_t data3)
{
    HID_Buf[0] = data0;
    HID_Buf[1] = data1;
    HID_Buf[2] = data2;
    HID_Buf[3] = data3;
    memcpy(pEP1_IN_DataBuf, HID_Buf, sizeof(HID_Buf));
    DevEP1_IN_Deal(sizeof(HID_Buf));
}

/*********************************************************************
 * @fn      DevWakeup
 *
 * @brief   豸ģʽ
 *
 * @return  none
 */
void DevWakeup(void)
{
    R16_PIN_ANALOG_IE &= ~(RB_PIN_USB_DP_PU);
    R8_UDEV_CTRL |= RB_UD_LOW_SPEED;
    mDelaymS(2);
    R8_UDEV_CTRL &= ~RB_UD_LOW_SPEED;
    R16_PIN_ANALOG_IE |= RB_PIN_USB_DP_PU;
}

/*********************************************************************
 * @fn      DebugInit
 *
 * @brief   Գʼ
 *
 * @return  none
 */
void DebugInit(void)
{
    GPIOA_SetBits(GPIO_Pin_9);
    GPIOA_ModeCfg(GPIO_Pin_8, GPIO_ModeIN_PU);
    GPIOA_ModeCfg(GPIO_Pin_9, GPIO_ModeOut_PP_5mA);
    UART1_DefInit();
}

/*********************************************************************
 * @fn      main
 *
 * @brief   
 *
 * @return  none
 */
int main()
{
    uint8_t s;
    SetSysClock(CLK_SOURCE_PLL_60MHz);

    DebugInit();        //ô1prinftdebug
    printf("start\n");

    pEP0_RAM_Addr = EP0_Databuf;    //û64ֽڡ
    pEP1_RAM_Addr = EP1_Databuf;

    USB_DeviceInit();

    PFIC_EnableIRQ(USB_IRQn);       //ж
    mDelaymS(100);

    while(1)
    {//ģ⴫4ֽڵݣʵʴûҪ޸
        if(Ready)
        {
            Ready = 0;
            DevHIDReport(0x05, 0x10, 0x20, 0x11);
        }
        mDelaymS(100);

        if(Ready)
        {
            Ready = 0;
            DevHIDReport(0x0A, 0x15, 0x25, 0x22);
        }
        mDelaymS(100);

        if(Ready)
        {
            Ready = 0;
            DevHIDReport(0x0E, 0x1A, 0x2A, 0x44);
        }
        mDelaymS(100);

        if(Ready)
        {
            Ready = 0;
            DevHIDReport(0x10, 0x1E, 0x2E, 0x88);
        }
        mDelaymS(100);
    }
}

/*********************************************************************
 * @fn      DevEP1_OUT_Deal
 *
 * @brief   ˵1ݴյݺȡٷȥûиġ
 *
 * @return  none
 */
void DevEP1_OUT_Deal(uint8_t l)
{ /* ûԶ */
    uint8_t i;

    for(i = 0; i < l; i++)
    {
        pEP1_IN_DataBuf[i] = ~pEP1_OUT_DataBuf[i];
    }
    DevEP1_IN_Deal(l);
}


/*********************************************************************
 * @fn      USB_IRQHandler
 *
 * @brief   USBжϺ
 *
 * @return  none
 */
__attribute__((interrupt("WCH-Interrupt-fast")))
__attribute__((section(".highcode")))
void USB_IRQHandler(void) /* USBжϷ,ʹüĴ1 */
{
    USB_DevTransProcess();
}
